package de._82grfl1bif.KPI_Visualizer.commands;

import de._82grfl1bif.KPI_Visualizer.data.DataHolder;
import de._82grfl1bif.KPI_Visualizer.structures.Builder;
import de._82grfl1bif.KPI_Visualizer.structures.Building;
import de._82grfl1bif.KPI_Visualizer.structures.Structure;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.Server;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.jetbrains.annotations.NotNull;

import java.util.logging.Level;

public class SetPreset implements CommandExecutor {

    @Override
    public boolean onCommand(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        Server server = sender.getServer();
        Builder builder = new Builder(server);
        Player player = server.getPlayer(sender.getName());
        if (player != null) {
            Location location = player.getLocation();
            if (args.length != 1) {
                sender.sendMessage("try with one Number behind the command.");
                return false;
            } else {
                Runnable t = () -> {
                    DataHolder.foundation.setLocation(location);
                    DataHolder.generateSimpleData(Integer.parseInt(args[0]));
                    builder.setFoundation(location, DataHolder.foundation.getWidth().x, DataHolder.foundation.getWidth().y, DataHolder.foundation.getMaterial());
                    for (Structure structure : DataHolder.foundation.getChildren()) {
                        Building building = (Building) structure;
                        sender.sendMessage("bau" + building.toString());
                        builder.fillQube(building.getLocation(), building.getWidth().x, building.getHeight(), building.getWidth().y, building.getMaterial());//Not yet ready to print foundations
                    }
                };
                t.run();
            }
        } else {
            Bukkit.getLogger().log(Level.SEVERE, "Kein Spieler gefunden.");
            return false;
        }
        return true;
    }

}
