package de._82grfl1bif.KPI_Visualizer.commands;

import de._82grfl1bif.KPI_Visualizer.data.DataHolder;
import de._82grfl1bif.KPI_Visualizer.data.JsonParser;
import de._82grfl1bif.KPI_Visualizer.layouts.TreeMap.Rectangle;
import de._82grfl1bif.KPI_Visualizer.layouts.TreeMap.Row;
import de._82grfl1bif.KPI_Visualizer.layouts.TreeMap.SquarifiedTreemapLayout;
import de._82grfl1bif.KPI_Visualizer.structures.*;
import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.Server;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;
import org.jetbrains.annotations.NotNull;

import java.awt.*;
import java.util.Map;
import java.util.logging.Level;

public class generateLayout implements CommandExecutor {

    @Override
    public boolean onCommand(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        if (args.length < 2) {
            sender.sendMessage("please type or select the needed Arguments with tab.");
            return false;
        }
        sender.sendMessage("generating SimpleSquareLayout");
        Server server = sender.getServer();
        Builder builder = new Builder(server);
        Player player = server.getPlayer(sender.getName());
        JsonParser jsonParser = new JsonParser();
        if (!jsonParser.evalJson(args[0])) {
            sender.sendMessage("failed to parse Json");
            return false;
        }
        if (player != null) { //check if Player exists for getting Start coordinates.
            Location location = player.getLocation();
            if (args[1].equals("SquarifiedTreemap")) { //check 2. Argument whether to use SquarifiedTreemap or SimpleSquare Layout.
                BukkitRunnable t = new BukkitRunnable() {
                    @Override
                    public void run() {
                        SquarifiedTreemapLayout squarifiedTreemapLayout = new SquarifiedTreemapLayout();
                        squarifiedTreemapLayout.generateLayout(DataHolder.foundation, new Rectangle(DataHolder.foundation.getArea(), Math.sqrt(DataHolder.foundation.getArea()), new Point(0, 0)));
                        builder.setFoundation(location,(int)Math.round(Math.sqrt(DataHolder.foundation.getArea())),(int)Math.round(Math.sqrt(DataHolder.foundation.getArea())), Material.COBBLESTONE);
                        for (Row row : squarifiedTreemapLayout.getRows()) {
                            for (Map.Entry<Rectangle, Structure> entry : row.getRectangles().entrySet()) {
                                Rectangle r = entry.getKey();
                                Structure s = entry.getValue();
                                if(s.getClass() == Foundation.class){
                                    builder.setFoundation(location.clone().add(r.getOrigin().x,s.getDepth(),r.getOrigin().y),(int)(r.getWidth()),(int)(r.getHeight()),s.getMaterial());
                                }else{
                                    builder.fillQube(location.clone().add(r.getOrigin().x,s.getDepth()+100,r.getOrigin().y),(int)(r.getWidth()),((Building)s).getHeight(),(int)(r.getHeight()),s.getMaterial());
                                }
                                if(r.getHeight() >= 5 && r.getWidth() >= 5){

                                }else{
                                    Bukkit.getLogger().log(Level.SEVERE,"the rectangle is too small");
                                }
                            }
                        }
                    }
                };
                t.run();
                return true;
            } else {
                BukkitRunnable t = new BukkitRunnable() {
                    @Override
                    public void run() {
                        DataHolder.foundation.setLocation(location);
                        DataHolder.foundation.organizeFoundation();
                        DataHolder.foundation.correctAllLocations(location);
                        builder.setFoundation(DataHolder.foundation.getLocation().clone().add(0, DataHolder.foundation.getDepth(), 0), DataHolder.foundation.getWidth().x, DataHolder.foundation.getWidth().x, DataHolder.foundation.getMaterial());
                        builder.setAllChildren(DataHolder.foundation);
                    }
                };
                t.run();
                return true;
            }

        } else {
            Bukkit.getLogger().log(Level.SEVERE, "Kein Spieler gefunden.");
            return false;
        }
    }

}
