package de._82grfl1bif.KPI_Visualizer.data;

import org.bukkit.Bukkit;
import org.jetbrains.annotations.NotNull;
import org.json.simple.JSONArray;
import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;

import java.io.*;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.logging.Level;

public class JsonParser {
    String standardPath = System.getProperty("user.dir");

    public boolean evalJson(@NotNull String fileName) {
        if (!fileName.contains(".json")) {
            fileName = fileName + ".json";
        } //Add .json in case user forgets
        if (!(fileName.contains("/"))) {
            fileName = standardPath + "/" + fileName;
        }
        try (FileReader jsonFileReader = new FileReader(fileName)) {
            JSONParser parser = new JSONParser();
            JSONObject jsonObject = (JSONObject) parser.parse(jsonFileReader);
            if (!(getFileHistory().contains(fileName))) { //if file isn't in history add it.
                try (BufferedWriter bufferedWriter = new BufferedWriter(new FileWriter(standardPath + "/plugins/JsonFileHistory",true))){
                    bufferedWriter.newLine();
                    bufferedWriter.write(fileName);
                } catch (Exception e) {
                    Bukkit.getLogger().log(Level.SEVERE, String.valueOf(e));
                }
            }
            JSONArray entities = (JSONArray) jsonObject.get("entities");
            ArrayList<Klasse> entitiesList = new ArrayList<>();
            for (int i=0; i < entities.size(); i++) {
                JSONObject object = (JSONObject) entities.get(i);
                Klasse currentKlasse = new Klasse(
                        Integer.parseInt(object.get("entity_id").toString()),
                        object.get("name").toString(),
                        object.get("path").toString(),
                        Integer.parseInt(object.get("qloc").toString()),
                        Integer.parseInt(object.get("loc").toString()),
                        ((JSONArray) object.get("commits")).size(),
                        ((JSONArray) object.get("functions")).size(),
                        ((JSONArray) object.get("variables")).size());
                entitiesList.add(currentKlasse);
            }
            entitiesList.sort(new DepthComparator());
            DataHolder.generateTreeFromKlassenList(entitiesList);
        } catch (Exception ex) {
            Bukkit.getLogger().log(Level.SEVERE, String.valueOf(ex));
            return false;
        }
        return true;
    }

    private static class DepthComparator implements Comparator<Klasse> {
        @Override
        public int compare(Klasse o1, Klasse o2) {
            return Integer.compare(o1.depth,o2.depth);
        }
    }

    public List<String> getFileHistory() {
        String path = System.getProperty("user.dir");
        String fileName = "/plugins/JsonFileHistory";
        List<String> filesInHistory = new ArrayList<>();
        try {
            File file = new File(path + fileName);
            if (file.createNewFile()) {//Create file
                return null;
            } //File exists
            BufferedReader br = new BufferedReader(new FileReader(path + fileName));
            String line;
            while ((line = br.readLine()) != null) {
                filesInHistory.add(line);
            }
            br.close();
        } catch (Exception e) {
            Bukkit.getLogger().log(Level.SEVERE, String.valueOf(e));
            return null;
        }
        return filesInHistory;
    }
}
