package de._82grfl1bif.KPI_Visualizer.structures;

import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.Server;
import org.bukkit.block.Block;

public class Builder {

    Server server;

    public Builder(Server server) {
        this.server = server;
    }

    public void setFoundation(Location startLocation, int x, int z, Material material) {
        for (int cx = 0; cx < x; cx++) {
            for (int cz = 0; cz < z; cz++) {
                Block block = server.getWorlds().get(0).getBlockAt(startLocation.clone().add(cx, 0, cz));
                block.setType(material);
            }
        }
    }

    public void fillQube(Location startLocation, int x, int y, int z, Material material) {
        for (int cy = 0; cy < y; cy++) {
            setFoundation(startLocation.clone().add(0, cy, 0), x, z, material);
        }
    }

    private void setWalls(Location startLocation, int x, int y, int z, Material innerMaterial, Material glassMaterial) {
        Location temp = startLocation.clone().add(0,0,1);
        for (int cz = 0; cz < z - 2; cz++) {//00-0Z
            for (int cy = 0; cy < y; cy++) {
                server.getWorlds().get(0).getBlockAt(temp.clone().add(1, cy, cz)).setType(innerMaterial);
                server.getWorlds().get(0).getBlockAt(temp.clone().add(0, cy, cz)).setType(glassMaterial);
            }
        }
        temp = startLocation.clone().add(1,0,0);
        for (int cx = 0; cx < x - 2; cx++) {//00-0X
            for (int cy = 0; cy < y; cy++) {
                server.getWorlds().get(0).getBlockAt(temp.clone().add(cx, cy, 1)).setType(innerMaterial);
                server.getWorlds().get(0).getBlockAt(temp.clone().add(cx, cy, 0)).setType(glassMaterial);
            }
        }
        temp = startLocation.clone().add(1, 0, z - 1);
        for (int cx = 0; cx < x - 2; cx++) {//0Z-ZX
            for (int cy = 0; cy < y; cy++) {
                server.getWorlds().get(0).getBlockAt(temp.clone().add(cx, cy, -1)).setType(innerMaterial);
                server.getWorlds().get(0).getBlockAt(temp.clone().add(cx, cy, 0)).setType(glassMaterial);

            }
        }
        temp = startLocation.clone().add(x - 1, 0, 1);
        for (int cz = 0; cz < z - 2; cz++) {//0X-XZ
            for (int cy = 0; cy < y; cy++) {
                server.getWorlds().get(0).getBlockAt(temp.clone().add(-1, cy, cz)).setType(innerMaterial);
                server.getWorlds().get(0).getBlockAt(temp.clone().add(0, cy, cz)).setType(glassMaterial);

            }
        }
    }

    private void setCorners(Location startLocation, int x, int y, int z, Material facade) {
        Location temp = startLocation.clone();
        for (int cy = 0; cy < y; cy++) {
            server.getWorlds().get(0).getBlockAt(temp.clone().add(0, cy, 0)).setType(facade);
        }
        temp = startLocation.clone().add(x - 1, 0, 0);
        for (int cy = 0; cy < y; cy++) {
            server.getWorlds().get(0).getBlockAt(temp.clone().add(0, cy, 0)).setType(facade);
        }
        temp = startLocation.clone().add(0, 0, z - 1);
        for (int cy = 0; cy < y; cy++) {
            server.getWorlds().get(0).getBlockAt(temp.clone().add(0, cy, 0)).setType(facade);
        }
        temp = startLocation.clone().add(x - 1, 0, z - 1);
        for (int cy = 0; cy < y; cy++) {
            server.getWorlds().get(0).getBlockAt(temp.clone().add(0, cy, 0)).setType(facade);
        }
    }

    public void buildBuilding(Location startLocation, int x, int y, int z, Material material) {
        setWalls(startLocation, x, y, z, material, Material.GLASS);
        setCorners(startLocation, x, y, z, Material.BLACKSTONE);
        setFoundation(startLocation.clone().add(0, y, 0), x, z, Material.BLACKSTONE);//roof
    }

    public void setAllChildren(Foundation foundation) {
        for (Structure s : foundation.getChildren()) {
            if (s.getClass() == Foundation.class) {//TODO must be revisited to draw rectangular Foundations
                this.setFoundation(s.getLocation().clone().add(0, s.getDepth(), 0), s.getWidth().x, s.getWidth().x, s.getMaterial());
                setAllChildren((Foundation) s);
            } else {//TODO must be revisited to draw rectangular Buildings
                this.buildBuilding(s.getLocation().clone().add(1, s.getDepth(), 1), s.getWidth().x - 2, ((Building) s).getHeight(),s.getWidth().x-2, s.getMaterial());
            }
        }
    }
}
